searchData={"content_type":"text/markdown","items":[{"doc":"Consume your LiveQuery queries from your Phoenix.LiveViews!","ref":"LiveQuery.Clients.LiveView.html","title":"LiveQuery.Clients.LiveView","type":"module"},{"doc":"This is the hook which sets up and manages the all your LiveView's LiveQuery interactions.\nYou should consider this a black box.\nIt takes 2 things, `:name` and `:assign`.\n`:name` is the name of your LiveQuery system.\n`:assign` is the name of the assign at which you'd like your client ref to be stored. This library will place it there for you.\nYour client ref must be passed to every callsite of `use_query/2`.\nThis ref will change every time a query that you're using changes.\nOther than that, it should be considered an opaque data structure.\n\n```elixir\ndef YourAppWeb.YourLiveView do\n  use YourAppWeb, :live_view\n\n  on_mount {LiveQuery.Clients.LiveView, name: YourApp.LiveQuery, assign: :lq_ref}\n\n  ...\nend\n```","ref":"LiveQuery.Clients.LiveView.html#on_mount/4","title":"LiveQuery.Clients.LiveView.on_mount/4","type":"function"},{"doc":"Use a query in from a LiveView live component.\nThe first argument is your client ref, which you'll get from the `on_mount` hook.\nIf no query_key is provided, the query_def is used as the query_key (useful for singleton queries).\nThis will return link the live_view to the query for as long as at least 1 live_component in the live_view is using the query.\nThis will return the value of the query, and will automatically rerender the live_view when the query changes.\n\n```elixir\ndefmodule YourAppWeb.YourLiveComponent do\n  use PhxTestAppWeb, :live_component\n\n  @impl true\n  def render(assigns) do\n    ~H\"\"\"\n       \n    \"\"\"\n  end\n\n  @impl true\n  def update(assigns, socket) do\n    {:ok,\n     socket\n     |> assign(:lq_ref, assigns.lq_ref)\n     |> assign(:value, LiveQuery.Clients.LiveView.use_query(assigns.lq_ref, :your_query_key, YourApp.YourQueryDef))}\n  end\nend\n```","ref":"LiveQuery.Clients.LiveView.html#use_query/4","title":"LiveQuery.Clients.LiveView.use_query/4","type":"function"}]}